   -- ⥪  ࠡ  ᪮襭묨 ॢﬨ
   -- (Splay Tree).
   -- ॡ 䠩 Tree.hs (⥪  ࠡ 
   -- ᫮묨 묨 ॢﬨ ᪠).
   --
   -- : 楢 .. (13.03.2012)
   --------------------------------------
   module SplTree
      (rot_Right, rot_Right', rot_Left, rotInTree, 
       zigZag_R, zigZag_L, zigZig_R, zigZig_L, sparPov,
       addInRoot, addInRoot1)
   where

   import Tree
   --------------------------------------------------
   -- 㭪樨, 騥  " ࠢ"
   --------------------------------------------------
   rot_Right:: BTree -> BTree
   rot_Right tree | isEmpty tree || isEmpty (left tree)
                         = tree
                  | True = node (root (left tree))
                                (left (left tree))
                                (node (root tree)
                                      (right (left tree))
                                      (right tree))
   ------------------------------------------------
   rot_Right':: BTree -> BTree
   rot_Right' NIL                       = nil
   rot_Right' (Node q NIL c)            = node q nil c
   rot_Right' (Node q (Node p a b) c)   = node p a (node q b c)
   ------------------------------------------------------------
   -- 㭪,   " "
   -------------------------------------------------
   rot_Left:: BTree -> BTree
   rot_Left tree | isEmpty tree || isEmpty (right tree)
                        = tree
                 | True = node (root (right tree))
                               (node (root tree)
                                     (left tree)
                                     (left (right tree)))
                               (right (right tree))
   ---------------------------------------------------------
   -- 㭪,  ᫮ ୮ ॢ ᪠,
   -- 祭  १ ⭮ ਬ -
   -- 樨 "", ந     ॢ  Tree,
   --  設 a   ஢ 
   ------------------------------------------
   rotInTree:: Int -> BTree -> BTree
   rotInTree a tree | isEmpty tree = nil
                    | root tree==a = tree
                    | not (isEmpty (left tree)) &&
                      root (left tree)==a
                                   = rot_Right tree
                    | not (isEmpty (right tree)) &&
                      root (right tree)==a
                                   = rot_Left tree
                    | True = node (root tree)
                                  (rotInTree a (left tree))
                                  (rotInTree a (right tree))
   ---------------------------------------------------------
   -- 㭪,   "ᯠ७ ஭
   --  ࠢ"
   -------------------------
   zigZag_R:: BTree -> BTree
   zigZag_R tree | isEmpty tree || isEmpty (right (left tree))
                        = tree
                 | True = rot_Right (rotInTree
                                        (root (right (left tree)))
                                        tree)
   ---------------------------------------------------------
   -- 㭪,   "ᯠ७ ஭
   --  "
   -------------------------
   zigZag_L:: BTree -> BTree
   zigZag_L tree | isEmpty tree || isEmpty (left (right tree))
                        = tree
                 | True = rot_Left (rotInTree
                                       (root (left (right tree)))
                                       tree)
   ----------------------------------------------------------
   -- 㭪,   "ᯠ७ ஭
   --  ࠢ"
   -------------------------
   zigZig_R:: BTree -> BTree
   zigZig_R tree | isEmpty tree || isEmpty (left (left tree))
                        = tree
                 | True = rot_Right (rot_Right tree)
   ----------------------------------------------------------
   -- 㭪,   "ᯠ७ ஭
   --  "
   -------------------------
   zigZig_L:: BTree -> BTree
   zigZig_L tree | isEmpty tree || isEmpty (right (right tree))
                        = tree
                 | True = rot_Left (rot_Left tree)
   ---------------------------------------------------------
   -- 㭪,  ᫮ ୮ ॢ ᪠,
   -- 祭  १ ਬ 樨 "ᯠ७
   -- ", ந    ॢ Tree, ୥
   -- ॢ ண  設 a
   ----------------------------------------
   sparPov:: Int -> BTree -> BTree
   sparPov a tree | isEmpty tree = nil
                  | not (isEmpty (left tree))  &&
                    not (isEmpty (right tree)) &&
                    (root tree==a || root (left tree)==a ||
                     root (right tree)==a)
                                 = tree
                  | not (isEmpty (right (left tree))) &&
                    root (right (left tree))==a
                                 = zigZag_R tree
                  | not (isEmpty (left (right tree))) &&
                    root (left (right tree))==a
                                 = zigZag_L tree
                  | not (isEmpty (left (left tree))) &&
                    root (left (left tree))==a
                                 = zigZig_R tree
                  | not (isEmpty (right (right tree))) &&
                    root (right (right tree))==a
                                 = zigZig_L tree
                  | True = node (root tree)
                                (sparPov a (left tree))
                                (sparPov a (right tree))
   -----------------------------------------------------
   -- 㭪,   "祭  ७
   -- ᫮ ୮ ॢ ᪠" ।⢮ -
   --  樨 ""
   ---------------------------------
   addInRoot:: Int -> BTree -> BTree
   addInRoot x tree | isEmpty tree = node x nil nil
                    | not (isEmpty (left tree)) &&
                      x==root (left tree)
                                   = rot_Right tree
                    | not (isEmpty (right tree)) &&
                      x==root (right tree)
                                   = rot_Left tree
                    | search x tree==nil
                                   = addInRoot x (addTree x tree)
                    | True = addInRoot x (rotInTree x tree)
   --------------------------------------------------------
   -- 㭪,   "祭   ७
   -- ᫮ ୮ ॢ ᪠" ।⢮ -
   --  樨 "ᯠ७ "  (, ,
   -- 樨 "")
   ----------------------------------
   addInRoot1:: Int -> BTree -> BTree
   addInRoot1 x tree | isEmpty tree = node x nil nil
                     | x==root tree = tree
                     | not (isEmpty (left tree)) &&
                       x==root (left tree)
                                    = rot_Right tree
                     | not (isEmpty (right tree)) &&
                       x==root (right tree)
                                    = rot_Left tree
                     | search x tree==nil
                                    = addInRoot1 x (addTree x tree)
                     | True = addInRoot1 x (sparPov x tree)
